import { Component, computed, OnInit, signal } from '@angular/core';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [],
  templateUrl: './app.component.html',
  styleUrl: './app.component.css',
})
export class AppComponent implements OnInit{
  title = 'ang-signal-simple';

  ngOnInit(){
    this.useNotSignals();
    this.useSignals();
  }

  /*
  Huippuyksinkertainen signaalien merkitystä demoava 
  esimerkki toteutettuna JS-koodilla TS-metodien sisällä.
  */

  // Ei signaaleja

  useNotSignals() {
    console.log('No signals');
    let x = 5;
    let y = 3;
    let z = x + y;
    console.log(z); // 8

    x = 10;
    console.log(z); // 8
  }

  // Signaalit

  useSignals() {
    console.log('Signals');
    const x = signal(5);
    const y = signal(3);
    const z = computed(() => x() + y());
    console.log(z()); // 8

    x.set(10);
    console.log(z()); // 13
  }
}
